using EVCB_OCPP.Packet.Features;
using EVCB_OCPP.Packet.Messages.SubTypes;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EVCB_OCPP.Packet.Messages.RemoteTrigger
{
    public class TriggerMessageRequest : IRequest
    {

        public TriggerMessageRequest()
        {
            Action = Actions.TriggerMessage.ToString();
        }

        [JsonIgnore]
        public string Action { set; get; }

        [Required]
        [JsonConverter(typeof(StringEnumConverter))]
        public MessageTrigger requestedMessage { set; get; }

        public int? connectorId { set; get; }

        public bool TransactionRelated()
        {
            return false;
        }

        public bool Validate()
        {
            return Validator.TryValidateObject(this, new ValidationContext(this), null, true);
        }
    }
}